/*
 * Copyright (C) 2011 Atmark Techno, Inc. All Rights Reserved.
 */

/*
 * The code contained herein is licensed under the GNU General Public
 * License. You may obtain a copy of the GNU General Public License
 * Version 2 or later at the following locations:
 *
 * http://www.opensource.org/licenses/gpl-license.html
 * http://www.gnu.org/copyleft/gpl.html
 */

#include <linux/platform_device.h>
#include <linux/leds.h>
#include <mach/common.h>
#include "armadillo400_iomux.h"

static struct pad_desc armadillo400_gpio_led_pads[] = {
	MX25_PAD_NFALE__GPIO_3_28(), /* red led */
	MX25_PAD_NFCLE__GPIO_3_29(), /* green led */
	MX25_PAD_BOOT_MODE0__GPIO_4_30(), /* yellow led */
};

#define GPIO_LED(_name, _default_trigger, _gpio, _active_low)	\
{								\
	.name = _name,						\
	.default_trigger = _default_trigger,			\
	.gpio = _gpio,						\
	.active_low = _active_low,				\
}

static struct gpio_led armadillo400_led_pins[] = {
	GPIO_LED("red",    "default-on", GPIO(3, 28), 0),
	GPIO_LED("green",  "default-on", GPIO(3, 29), 0),
	GPIO_LED("yellow", "none",       GPIO(4, 30), 0),
};

static struct gpio_led_platform_data armadillo400_gpio_led_data = {
	.leds = armadillo400_led_pins,
	.num_leds = ARRAY_SIZE(armadillo400_led_pins),
};

static struct platform_device armadillo400_gpio_led_device = {
	.name ="leds-gpio",
	.id = 0,
};

void __init armadillo400_led_init(void)
{
	mxc_iomux_v3a_setup_multiple_pads(armadillo400_gpio_led_pads);
	mxc_register_device(&armadillo400_gpio_led_device,
			    &armadillo400_gpio_led_data);
}
